﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Windows.Controls.Primitives;
using System.Collections;


namespace WpfApplication1
{
    public partial class MainWindow : Window
    {
        ItemList il;
        GroupList gl;

        public MainWindow()
        {
            InitializeComponent();
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            il = new ItemList();
            ICollectionView cvs = CollectionViewSource.GetDefaultView(il);
            cvs.SortDescriptions.Add(new SortDescription("_type", ListSortDirection.Ascending));
            cvs.SortDescriptions.Add(new SortDescription("_name", ListSortDirection.Ascending));
            cvs.GroupDescriptions.Add(new PropertyGroupDescription("_type"));
            ListBox2.ItemsSource = cvs;

            gl = new GroupList();
            ICollectionView cvt = CollectionViewSource.GetDefaultView(gl);
            ListBox1.ItemsSource = cvt;
        } 
    }

    public class Item
    {
        public string _type { get; set; }
        public string _name { get; set; }
        public Item()
        {
        }
    }
    public class ItemList : ObservableCollection<Item> {
        public ItemList() {
            base.Add(new Item() { _type = "fruit", _name = "apple"});
            base.Add(new Item() { _type = "vegetable", _name = "potato"});
            base.Add(new Item() { _type = "fruit", _name = "banana"});
            base.Add(new Item() { _type = "vegetable", _name = "tomato"});
            base.Add(new Item() { _type = "fruit", _name = "pear"});
            base.Add(new Item() { _type = "vegetable", _name = "salad"});
            base.Add(new Item() { _type = "fruit", _name = "orange"});
            base.Add(new Item() { _type = "vegetable", _name = "onion"}); 
        }
    }

    public class Group
    {
        public string _groupname { get; set; }
        public List<String> _members { get; set; }
        public string _recipe { get; set; }
        public Group()
        {
        }
    }
    public class GroupList : ObservableCollection<Group>
    {
        public GroupList()
        {
            base.Add(new Group() { _groupname = "Group_1", _members = new List<String>() { "apple", "salad" }, _recipe = "Do this and do that" });
            base.Add(new Group() { _groupname = "Group_2", _members = new List<String>() { "banana", "onion" }, _recipe = "Don't do that and do this" });
        }
    }
}
